    .model small,c
    .386
    .stack
    include support.asm
.data
    deviceId        dw 0
    deviceIndex     dw 0
    busNumber       db 0
    dev_func_number db 0
.code
.startup
    mov   ax,0b101h ; PCI BIOS v2.0c+ Installation Check
    mov   edi,0
    int   1ah
    jnc   @F
    print "PCI BIOS not installed",NL
    jmp   fini
  @@:
    print "Physical address of PM entry point: "
    print hexdword$(edi),"h",NL
    print "PCI hardware characteristics:",NL
    .IF al & 1
      print "Configuration space access mechanism 1 supported",NL
    .ENDIF
    .IF al & 2
      print "Configuration space access mechanism 2 supported",NL
    .ENDIF
    .IF al & 16
      print "Special Cycle generation mechanism 1 supported",NL
    .ENDIF
    .IF al & 32
      print "Special Cycle generation mechanism 2 supported",NL
    .ENDIF
    print "PCI interface level major version: ",hexbyte$(bh),NL
    print "PCI interface level minor version: ",hexbyte$(bl),NL
    print "Number of last PCI bus in system: ",hexbyte$(cl),"h",NL

    FOR vendorId, <8086h,110ah,1106h>
      mov   deviceId, 0
      .WHILE deviceId < 0ffffh
        mov   ax, 0b102h ; PCI BIOS v2.0c+ Find PCI Device
        mov   cx, deviceId
        mov   dx, vendorId
        mov   si, deviceIndex
        int   1ah
        .IF ah == 0
          print "DeviceID: ",hexword$(deviceId),"h"
          print " VendorID: ",hexword$(vendorId),"h"
          print " DeviceIndex: ",hexword$(deviceIndex),"h"
          print " Bus#: ", byte$(bh)
          print " Dev/Func#: ", byte$(bl),NL

          mov   ax, 0b10ah ; PCI BIOS v2.0c+ Read Configuration Dword
          mov   di, 0      ; Register number    
          int   1ah
          jnc   @F
          print "Unexpected error reading configuration Dword: ",hexbyte$(ah),NL
          jmp   fini
        @@:
          print "Configuration Dword (register 0): ", hexdword$(ecx),NL
          ;call waitkey
        .ELSEIF ah != 86h
          print "Unexpected error: ",hexbyte$(ah),NL
          jmp   fini
        .ENDIF
        inc   deviceId
      .ENDW
    ENDM  
  fini:
    print NL,NL,"Press any key to exit..."
    call waitkey
.exit
end

To enumerate devices, iterate through the deviceIndex values
until the error code in ah is 86h.

vendorId 8086h = Intel
vendorId 110Ah = Siemens AG / Siemens Nixdorf AG
vendorId 1106h = VIA Technologies

Others available here:

http://www.pcidatabase.com/

